import * as i0 from '@angular/core';
import { EventEmitter, Component, ChangeDetectionStrategy, Input, Output, Injectable, HostListener, Directive, ContentChildren, TemplateRef, HostBinding, NgModule } from '@angular/core';
import { trigger, transition, style, animate } from '@angular/animations';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1$1 from '@ng-bootstrap/ng-bootstrap';
import { NgbPagination, NgbModule } from '@ng-bootstrap/ng-bootstrap';
import * as i2 from '@angular/forms';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { Subscription, map, catchError, throwError } from 'rxjs';
import * as i2$1 from '@angular/common/http';
import { HttpHeaders, HttpParams, HttpClientModule } from '@angular/common/http';
import * as i1$2 from '@angular/router';

const SlideUpToggleAnimation = [
    trigger('slideUpToggle', [
        transition(':enter', [
            style({ transform: 'translateY(100%)' }),
            animate('200ms ease-in', style({ transform: 'translateY(0%)' })),
        ]),
        transition(':leave', [
            animate('200ms ease-in', style({ transform: 'translateY(100%)' })),
        ]),
    ]),
];

class DokuBottomSheetComponent {
    constructor(changeDetector) {
        this.changeDetector = changeDetector;
        this.flags = {
            isBottomSheetEnabled: false,
        };
        this.onClose = new EventEmitter();
    }
    /**
     * Opens bottom sheet component
     */
    open() {
        this.flags.isBottomSheetEnabled = true;
        this.changeDetector.detectChanges();
    }
    /**
     * Closes bottom sheet component
     */
    close() {
        this.flags.isBottomSheetEnabled = false;
        this.changeDetector.detectChanges();
        this.onClose.emit();
    }
}
DokuBottomSheetComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuBottomSheetComponent, deps: [{ token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
DokuBottomSheetComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: DokuBottomSheetComponent, selector: "doku-bottom-sheet", inputs: { options: "options" }, outputs: { onClose: "onClose" }, ngImport: i0, template: "<div\n  class=\"bottom-sheet-bg-overlay\"\n  *ngIf=\"flags.isBottomSheetEnabled\"\n  (click)=\"close()\"\n></div>\n<div\n  class=\"bottom-sheet-container\"\n  [ngClass]=\"{ 'bg-dark': options.darkTheme }\"\n  *ngIf=\"flags.isBottomSheetEnabled\"\n  [style.backgroundColor]=\"options.backgroundColor\"\n  [style.color]=\"options.fontColor\"\n  [@slideUpToggle]\n>\n  <div>\n    <div\n      class=\"bottom-sheet-header\"\n      *ngIf=\"options.showHeader\"\n      [ngClass]=\"{\n        'bg-dark-header': options.darkTheme,\n        'border-0': options.disableHeaderBorder\n      }\"\n    >\n      <h4 class=\"title\" [ngClass]=\"{ 'title-dark': options.darkTheme }\">\n        {{ options.title }}\n      </h4>\n      <button\n        *ngIf=\"options.enableHeaderCloseButton\"\n        type=\"button\"\n        class=\"btn-close\"\n        aria-label=\"Close\"\n        (click)=\"close()\"\n      ></button>\n    </div>\n\n    <div class=\"bottom-sheet-content\">\n      <ng-content></ng-content>\n    </div>\n\n    <div\n      class=\"bottom-sheet-footer\"\n      [ngClass]=\"{ 'bg-dark-footer': options.darkTheme }\"\n      (click)=\"close()\"\n      *ngIf=\"options.enableCloseButton\"\n    >\n      {{ options.closeButtonTitle ? options.closeButtonTitle : \"Close\" }}\n    </div>\n  </div>\n</div>\n", styles: [".bottom-sheet-bg-overlay{background:rgba(0,0,0,.32);position:fixed;inset:0;z-index:1}.bottom-sheet-container{background:#fff;width:100%;position:fixed;bottom:0;border-radius:8px 8px 0 0;left:50%;margin-left:-35%;width:75%;z-index:4;color:#363636;box-shadow:0 8px 10px -5px #0003,0 16px 24px 2px #00000024,0 6px 30px 5px #0000001f}.bg-dark{color:#ffffffe6;background:#363636}.bottom-sheet-header h4.title{display:inline-block;font-weight:500;margin:0;font-size:1rem}.bottom-sheet-header{border-bottom:1px solid rgba(0,0,0,.16);padding:16px;display:flex;justify-content:space-between;align-items:center}.bg-dark-header{border-bottom:1px solid rgba(255,255,255,.16)}.bottom-sheet-footer{text-align:center;padding:16px;border-top:1px solid rgba(0,0,0,.16);background:rgba(0,0,0,.02);cursor:pointer}.bg-dark-footer{border-top:1px solid rgba(255,255,255,.16)}.title-dark{color:#ffffffe6}.bottom-sheet-content{max-height:300px;overflow-y:auto;padding:16px}::-webkit-scrollbar{width:4px}::-webkit-scrollbar-track{background:#bdbdbd}::-webkit-scrollbar-thumb{background:#888}::-webkit-scrollbar-thumb:hover{background:rgb(92,92,92)}@media (max-width: 992px){.bottom-sheet-container{width:100%;position:fixed;bottom:0;left:0;right:0;margin-left:0}}\n"], dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], animations: [SlideUpToggleAnimation], changeDetection: i0.ChangeDetectionStrategy.OnPush });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuBottomSheetComponent, decorators: [{
            type: Component,
            args: [{ selector: 'doku-bottom-sheet', animations: [SlideUpToggleAnimation], changeDetection: ChangeDetectionStrategy.OnPush, template: "<div\n  class=\"bottom-sheet-bg-overlay\"\n  *ngIf=\"flags.isBottomSheetEnabled\"\n  (click)=\"close()\"\n></div>\n<div\n  class=\"bottom-sheet-container\"\n  [ngClass]=\"{ 'bg-dark': options.darkTheme }\"\n  *ngIf=\"flags.isBottomSheetEnabled\"\n  [style.backgroundColor]=\"options.backgroundColor\"\n  [style.color]=\"options.fontColor\"\n  [@slideUpToggle]\n>\n  <div>\n    <div\n      class=\"bottom-sheet-header\"\n      *ngIf=\"options.showHeader\"\n      [ngClass]=\"{\n        'bg-dark-header': options.darkTheme,\n        'border-0': options.disableHeaderBorder\n      }\"\n    >\n      <h4 class=\"title\" [ngClass]=\"{ 'title-dark': options.darkTheme }\">\n        {{ options.title }}\n      </h4>\n      <button\n        *ngIf=\"options.enableHeaderCloseButton\"\n        type=\"button\"\n        class=\"btn-close\"\n        aria-label=\"Close\"\n        (click)=\"close()\"\n      ></button>\n    </div>\n\n    <div class=\"bottom-sheet-content\">\n      <ng-content></ng-content>\n    </div>\n\n    <div\n      class=\"bottom-sheet-footer\"\n      [ngClass]=\"{ 'bg-dark-footer': options.darkTheme }\"\n      (click)=\"close()\"\n      *ngIf=\"options.enableCloseButton\"\n    >\n      {{ options.closeButtonTitle ? options.closeButtonTitle : \"Close\" }}\n    </div>\n  </div>\n</div>\n", styles: [".bottom-sheet-bg-overlay{background:rgba(0,0,0,.32);position:fixed;inset:0;z-index:1}.bottom-sheet-container{background:#fff;width:100%;position:fixed;bottom:0;border-radius:8px 8px 0 0;left:50%;margin-left:-35%;width:75%;z-index:4;color:#363636;box-shadow:0 8px 10px -5px #0003,0 16px 24px 2px #00000024,0 6px 30px 5px #0000001f}.bg-dark{color:#ffffffe6;background:#363636}.bottom-sheet-header h4.title{display:inline-block;font-weight:500;margin:0;font-size:1rem}.bottom-sheet-header{border-bottom:1px solid rgba(0,0,0,.16);padding:16px;display:flex;justify-content:space-between;align-items:center}.bg-dark-header{border-bottom:1px solid rgba(255,255,255,.16)}.bottom-sheet-footer{text-align:center;padding:16px;border-top:1px solid rgba(0,0,0,.16);background:rgba(0,0,0,.02);cursor:pointer}.bg-dark-footer{border-top:1px solid rgba(255,255,255,.16)}.title-dark{color:#ffffffe6}.bottom-sheet-content{max-height:300px;overflow-y:auto;padding:16px}::-webkit-scrollbar{width:4px}::-webkit-scrollbar-track{background:#bdbdbd}::-webkit-scrollbar-thumb{background:#888}::-webkit-scrollbar-thumb:hover{background:rgb(92,92,92)}@media (max-width: 992px){.bottom-sheet-container{width:100%;position:fixed;bottom:0;left:0;right:0;margin-left:0}}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }]; }, propDecorators: { options: [{
                type: Input
            }], onClose: [{
                type: Output
            }] } });

class DokuBottomSheetConfig {
    constructor() {
        this.showHeader = true;
    }
}

class DokuConfirmationModalComponent {
    constructor(activeModal) {
        this.activeModal = activeModal;
        this.loadingSubmit = false;
        this.cancelText = 'Cancel';
        this.confirmOutput = new EventEmitter();
    }
    sendOutput() {
        this.loadingSubmit = true;
        this.confirmOutput.emit(true);
    }
}
DokuConfirmationModalComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuConfirmationModalComponent, deps: [{ token: i1$1.NgbActiveModal }], target: i0.ɵɵFactoryTarget.Component });
DokuConfirmationModalComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: DokuConfirmationModalComponent, selector: "doku-confirmation-modal", inputs: { title: "title", subtitle: "subtitle", buttonTitle: "buttonTitle", loadingSubmit: "loadingSubmit", cancelText: "cancelText" }, outputs: { confirmOutput: "confirmOutput" }, ngImport: i0, template: "<div class=\"modal-header\">\n  <h5 class=\"modal-title\">\n    <div class=\"event-icon d-flex\">\n      <div>\n        <img\n          src=\"https://cdn-dev.oss-ap-southeast-5.aliyuncs.com/doku-ui-framework/doku/img/modal-ornament/warning-icon.png\"\n          alt=\"\"\n        />\n      </div>\n      <div class=\"header-content\">\n        <h4 class=\"confirmation-modal-title\">{{ title }}</h4>\n      </div>\n    </div>\n  </h5>\n</div>\n<div class=\"modal-body\">\n  <p>{{ subtitle }}</p>\n</div>\n<div class=\"modal-footer\">\n  <button\n    type=\"button\"\n    class=\"btn btn-link\"\n    style=\"color: #e1251b !important\"\n    (click)=\"activeModal.dismiss()\"\n  >\n    {{ cancelText }}\n  </button>\n  <button\n    type=\"button\"\n    class=\"btn btn-primary position-relative\"\n    [class.is-loading]=\"loadingSubmit\"\n    (click)=\"sendOutput()\"\n  >\n    <span [class.hide]=\"loadingSubmit\">{{\n      buttonTitle ? buttonTitle : \"SAVE\"\n    }}</span>\n    <span [class.hide]=\"!loadingSubmit\" class=\"spinner\">\n      <span\n        class=\"spinner-border spinner-border-sm\"\n        role=\"status\"\n        aria-hidden=\"true\"\n      ></span>\n    </span>\n  </button>\n</div>\n", styles: [".spinner{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}.hide{visibility:hidden}\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuConfirmationModalComponent, decorators: [{
            type: Component,
            args: [{ selector: 'doku-confirmation-modal', template: "<div class=\"modal-header\">\n  <h5 class=\"modal-title\">\n    <div class=\"event-icon d-flex\">\n      <div>\n        <img\n          src=\"https://cdn-dev.oss-ap-southeast-5.aliyuncs.com/doku-ui-framework/doku/img/modal-ornament/warning-icon.png\"\n          alt=\"\"\n        />\n      </div>\n      <div class=\"header-content\">\n        <h4 class=\"confirmation-modal-title\">{{ title }}</h4>\n      </div>\n    </div>\n  </h5>\n</div>\n<div class=\"modal-body\">\n  <p>{{ subtitle }}</p>\n</div>\n<div class=\"modal-footer\">\n  <button\n    type=\"button\"\n    class=\"btn btn-link\"\n    style=\"color: #e1251b !important\"\n    (click)=\"activeModal.dismiss()\"\n  >\n    {{ cancelText }}\n  </button>\n  <button\n    type=\"button\"\n    class=\"btn btn-primary position-relative\"\n    [class.is-loading]=\"loadingSubmit\"\n    (click)=\"sendOutput()\"\n  >\n    <span [class.hide]=\"loadingSubmit\">{{\n      buttonTitle ? buttonTitle : \"SAVE\"\n    }}</span>\n    <span [class.hide]=\"!loadingSubmit\" class=\"spinner\">\n      <span\n        class=\"spinner-border spinner-border-sm\"\n        role=\"status\"\n        aria-hidden=\"true\"\n      ></span>\n    </span>\n  </button>\n</div>\n", styles: [".spinner{position:absolute;top:50%;left:50%;transform:translate(-50%,-50%)}.hide{visibility:hidden}\n"] }]
        }], ctorParameters: function () { return [{ type: i1$1.NgbActiveModal }]; }, propDecorators: { title: [{
                type: Input
            }], subtitle: [{
                type: Input
            }], buttonTitle: [{
                type: Input
            }], loadingSubmit: [{
                type: Input
            }], cancelText: [{
                type: Input
            }], confirmOutput: [{
                type: Output
            }] } });

class DokuPaginationComponent extends NgbPagination {
    constructor() {
        super(...arguments);
        this.label = 'Item per page';
        this.pageSizeChange = new EventEmitter();
        this.pagePerSizeList = [5, 10, 25];
    }
    onPageChange() {
        this.pageChange.emit(this.page);
    }
    onPageSizeChange() {
        this.pageSizeChange.emit(this.pageSize);
    }
    get typeOfLabel() {
        return typeof this.label;
    }
}
DokuPaginationComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuPaginationComponent, deps: null, target: i0.ɵɵFactoryTarget.Component });
DokuPaginationComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: DokuPaginationComponent, selector: "doku-pagination", inputs: { label: "label" }, outputs: { pageSizeChange: "pageSizeChange" }, usesInheritance: true, ngImport: i0, template: "<div class=\"justify-content-end d-block d-md-flex p-2\">\n  <select class=\"form-select mr-auto\" style=\"width: auto\" name=\"pageSize\" [value]=\"6\"\n    [(ngModel)]=\"pageSize\" (ngModelChange)=\"onPageSizeChange()\">\n\n    <option [ngValue]=\"pagePerSizeValue\" *ngFor=\"let pagePerSizeValue of pagePerSizeList\">\n      <span *ngIf=\"typeOfLabel == 'string'\">{{pagePerSizeValue}} {{label}}</span>\n      <ng-container *ngIf=\"typeOfLabel == 'object'\" [ngTemplateOutlet]=\"label\"\n      [ngTemplateOutletContext]=\"{ size: pagePerSizeValue }\">\n      </ng-container>\n    </option>\n\n  </select>\n\n  <ngb-pagination\n      [collectionSize]=\"collectionSize\"\n      [(page)]=\"page\"\n      [maxSize]=\"maxSize\"\n      [pageSize]=\"pageSize\"\n      (pageChange)=\"onPageChange()\">\n  </ngb-pagination>\n</div>\n", dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i2.NgSelectOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.ɵNgSelectMultipleOption, selector: "option", inputs: ["ngValue", "value"] }, { kind: "directive", type: i2.SelectControlValueAccessor, selector: "select:not([multiple])[formControlName],select:not([multiple])[formControl],select:not([multiple])[ngModel]", inputs: ["compareWith"] }, { kind: "directive", type: i2.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i2.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i1$1.NgbPagination, selector: "ngb-pagination", inputs: ["disabled", "boundaryLinks", "directionLinks", "ellipses", "rotate", "collectionSize", "maxSize", "page", "pageSize", "size"], outputs: ["pageChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuPaginationComponent, decorators: [{
            type: Component,
            args: [{ selector: 'doku-pagination', template: "<div class=\"justify-content-end d-block d-md-flex p-2\">\n  <select class=\"form-select mr-auto\" style=\"width: auto\" name=\"pageSize\" [value]=\"6\"\n    [(ngModel)]=\"pageSize\" (ngModelChange)=\"onPageSizeChange()\">\n\n    <option [ngValue]=\"pagePerSizeValue\" *ngFor=\"let pagePerSizeValue of pagePerSizeList\">\n      <span *ngIf=\"typeOfLabel == 'string'\">{{pagePerSizeValue}} {{label}}</span>\n      <ng-container *ngIf=\"typeOfLabel == 'object'\" [ngTemplateOutlet]=\"label\"\n      [ngTemplateOutletContext]=\"{ size: pagePerSizeValue }\">\n      </ng-container>\n    </option>\n\n  </select>\n\n  <ngb-pagination\n      [collectionSize]=\"collectionSize\"\n      [(page)]=\"page\"\n      [maxSize]=\"maxSize\"\n      [pageSize]=\"pageSize\"\n      (pageChange)=\"onPageChange()\">\n  </ngb-pagination>\n</div>\n" }]
        }], propDecorators: { label: [{
                type: Input
            }], pageSizeChange: [{
                type: Output
            }] } });

class DokuLoaderService {
    constructor() {
        this.loading = false;
    }
    setLoading(loading) {
        this.loading = loading;
    }
    getLoading() {
        return this.loading;
    }
}
DokuLoaderService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuLoaderService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DokuLoaderService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuLoaderService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuLoaderService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class DokuSpinnerComponent {
    constructor(loader) {
        this.loader = loader;
        this.screenHeight = 0;
        this.screenWidth = 0;
    }
    ngOnInit() {
        this.onResize();
    }
    onResize() {
        this.screenHeight = window.innerHeight;
        this.screenWidth = window.innerWidth;
    }
    get spinnerClass() {
        if (this.screenWidth < 768) {
            return 'spinner-sm';
        }
        else if (this.screenWidth < 992) {
            return 'spinner-md';
        }
        else {
            return 'spinner-lg';
        }
    }
}
DokuSpinnerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuSpinnerComponent, deps: [{ token: DokuLoaderService }], target: i0.ɵɵFactoryTarget.Component });
DokuSpinnerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: DokuSpinnerComponent, selector: "doku-spinner", host: { listeners: { "window:resize": "onResize($event)" } }, ngImport: i0, template: "<div *ngIf=\"this.loader.getLoading()\" class=\"cssload-container\">\n  <div class=\"spinner-border text-primary\" [ngClass]=\"spinnerClass\"></div>\n</div>\n", styles: [".cssload-container{width:100%;height:100%;position:fixed;top:0;left:0;background:rgba(0,0,0,.5);z-index:1000;display:flex;align-items:center;justify-content:center}\n"], dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuSpinnerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'doku-spinner', template: "<div *ngIf=\"this.loader.getLoading()\" class=\"cssload-container\">\n  <div class=\"spinner-border text-primary\" [ngClass]=\"spinnerClass\"></div>\n</div>\n", styles: [".cssload-container{width:100%;height:100%;position:fixed;top:0;left:0;background:rgba(0,0,0,.5);z-index:1000;display:flex;align-items:center;justify-content:center}\n"] }]
        }], ctorParameters: function () { return [{ type: DokuLoaderService }]; }, propDecorators: { onResize: [{
                type: HostListener,
                args: ['window:resize', ['$event']]
            }] } });

const rotate = {
    asc: 'desc',
    desc: '',
    '': 'asc',
};
class DokuSortableHeaderColumnDirective {
    constructor() {
        this.sortable = '';
        this.direction = '';
        this.sort = new EventEmitter();
    }
    rotate() {
        console.log('test');
        this.direction = rotate[this.direction];
        let r = { column: this.sortable, direction: this.direction };
        this.sort.emit(r);
    }
}
DokuSortableHeaderColumnDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuSortableHeaderColumnDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
DokuSortableHeaderColumnDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.12", type: DokuSortableHeaderColumnDirective, selector: "th[doku-sortable]", inputs: { sortable: "sortable", direction: "direction" }, outputs: { sort: "sort" }, host: { listeners: { "click": "rotate()" }, properties: { "class.asc": "direction === \"asc\"", "class.desc": "direction === \"desc\"" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuSortableHeaderColumnDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'th[doku-sortable]',
                    host: {
                        '[class.asc]': 'direction === "asc"',
                        '[class.desc]': 'direction === "desc"',
                        '(click)': 'rotate()',
                    },
                }]
        }], propDecorators: { sortable: [{
                type: Input
            }], direction: [{
                type: Input
            }], sort: [{
                type: Output
            }] } });

class DokuSortableHeaderRowDirective {
    constructor() {
        this.subscriptions = new Subscription();
    }
    ngAfterViewInit() {
        var s = this.headers.forEach((header) => {
            header.sort.subscribe((v) => {
                this.reset(v.column);
            });
        });
        this.subscriptions.add(s);
    }
    reset(column) {
        this.headers.forEach((header) => {
            if (header.sortable !== column) {
                header.direction = '';
            }
        });
    }
    ngOnDestroy() {
        this.subscriptions.unsubscribe();
    }
}
DokuSortableHeaderRowDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuSortableHeaderRowDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
DokuSortableHeaderRowDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.12", type: DokuSortableHeaderRowDirective, selector: "tr[doku-sortable]", queries: [{ propertyName: "headers", predicate: DokuSortableHeaderColumnDirective }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuSortableHeaderRowDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'tr[doku-sortable]',
                }]
        }], propDecorators: { headers: [{
                type: ContentChildren,
                args: [DokuSortableHeaderColumnDirective]
            }] } });

class ToastService {
    constructor() {
        this.toasts = [];
        this.delay = 5000;
        this.toastOptions = {
            success: {
                classname: 'alert alert-success alert-flag',
                icon: 'fa-check-circle in-icon',
            },
            danger: {
                classname: 'alert alert-danger alert-flag',
                icon: 'fa-times-circle in-icon',
            },
            warning: {
                classname: 'alert alert-warning alert-flag',
                icon: 'fas fa-exclamation-circle in-icon',
            },
            dark: {
                classname: 'alert alert-dark alert-flag',
                icon: 'fas fa-question-circle in-icon',
            },
        };
    }
    /**
     *
     * @param type 'success' | 'danger' | 'warning' | 'dark'
     * @param textOrTpl  string OR TemplateRef<any>
     * @param delay numbers in miliseconds. e.g 1000 for 1s
     * @param isCentered boolean
     */
    showToast(type, textOrTpl, delay = this.delay, isCentered = false) {
        let newClass = JSON.parse(JSON.stringify(this.toastOptions[type]));
        isCentered
            ? (newClass.classname += ' toast-top-centered')
            : (newClass.classname += ' toast-top-right');
        this.show(textOrTpl, Object.assign(Object.assign({}, newClass), { delay }));
    }
    show(textOrTpl, options = {}) {
        this.toasts.push(Object.assign({ textOrTpl }, options));
    }
    remove(toast) {
        this.toasts = this.toasts.filter((t) => t !== toast);
    }
}
ToastService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ToastService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
ToastService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ToastService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: ToastService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }] });

class DokuToastComponent {
    constructor(toastService) {
        this.toastService = toastService;
    }
    isTemplate(toast) {
        return toast.textOrTpl instanceof TemplateRef;
    }
    ngOnDestroy() {
        this.toastService.toasts = [];
    }
}
DokuToastComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuToastComponent, deps: [{ token: ToastService }], target: i0.ɵɵFactoryTarget.Component });
DokuToastComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: DokuToastComponent, selector: "doku-toast", ngImport: i0, template: "<!-- toast default delay is 3s if not set, when hidden, toast will be deleted -->\n<ngb-toast\n  *ngFor=\"let toast of toastService.toasts\"\n  [class]=\"toast.classname\"\n  [autohide]=\"true\"\n  [delay]=\"toast.delay\"\n  (hidden)=\"toastService.remove(toast)\"\n>\n  <ng-template [ngIf]=\"isTemplate(toast)\" [ngIfElse]=\"text\">\n    <ng-template [ngTemplateOutlet]=\"toast.textOrTpl\"></ng-template>\n  </ng-template>\n  <ng-template #text>\n    <div>\n      <em [class]=\"'fas ' + toast.icon\"></em>\n    </div>\n    <div>\n      {{ toast.textOrTpl }}\n    </div>\n  </ng-template>\n</ngb-toast>\n", styles: [".toast-top-right{position:fixed;top:0;right:0;z-index:1200;margin:2em}.toast-top-centered{position:fixed;top:0;left:50%;transform:translate(-50%);z-index:1200;margin-top:2em}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i1.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "component", type: i1$1.NgbToast, selector: "ngb-toast", inputs: ["animation", "delay", "autohide", "header"], outputs: ["shown", "hidden"], exportAs: ["ngbToast"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuToastComponent, decorators: [{
            type: Component,
            args: [{ selector: 'doku-toast', template: "<!-- toast default delay is 3s if not set, when hidden, toast will be deleted -->\n<ngb-toast\n  *ngFor=\"let toast of toastService.toasts\"\n  [class]=\"toast.classname\"\n  [autohide]=\"true\"\n  [delay]=\"toast.delay\"\n  (hidden)=\"toastService.remove(toast)\"\n>\n  <ng-template [ngIf]=\"isTemplate(toast)\" [ngIfElse]=\"text\">\n    <ng-template [ngTemplateOutlet]=\"toast.textOrTpl\"></ng-template>\n  </ng-template>\n  <ng-template #text>\n    <div>\n      <em [class]=\"'fas ' + toast.icon\"></em>\n    </div>\n    <div>\n      {{ toast.textOrTpl }}\n    </div>\n  </ng-template>\n</ngb-toast>\n", styles: [".toast-top-right{position:fixed;top:0;right:0;z-index:1200;margin:2em}.toast-top-centered{position:fixed;top:0;left:50%;transform:translate(-50%);z-index:1200;margin-top:2em}\n"] }]
        }], ctorParameters: function () { return [{ type: ToastService }]; } });

class DokuToggleComponent {
    constructor() {
        this.onClicked = new EventEmitter();
        this.id = '';
        this.checked = false;
        this.disabled = false;
    }
    ngOnInit() { }
    onClick(event) {
        this.checked = !this.checked;
        this.onClicked.emit(this.checked);
    }
}
DokuToggleComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuToggleComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DokuToggleComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: DokuToggleComponent, selector: "doku-toggle", inputs: { id: "id", checked: "checked", disabled: "disabled" }, outputs: { onClicked: "onClicked" }, ngImport: i0, template: "<div class=\"custom-control custom-switch\">\n  <input\n    [id]=\"id\"\n    type=\"checkbox\"\n    class=\"switch\"\n    [checked]=\"checked\"\n    (input)=\"onClick($event)\"\n    [disabled]=\"disabled\"\n  />\n  <ng-content select=\"[label-toggle]\"></ng-content>\n</div>\n", styles: ["@import\"https://cdn-doku.oss-ap-southeast-5.aliyuncs.com/doku-ui-framework/css-doku@1.0.4/css/main.css\";@import\"https://cdn-doku.oss-ap-southeast-5.aliyuncs.com/doku-ui-framework/css-jokul/1.0.0/main.css\";\n"] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuToggleComponent, decorators: [{
            type: Component,
            args: [{ selector: 'doku-toggle', template: "<div class=\"custom-control custom-switch\">\n  <input\n    [id]=\"id\"\n    type=\"checkbox\"\n    class=\"switch\"\n    [checked]=\"checked\"\n    (input)=\"onClick($event)\"\n    [disabled]=\"disabled\"\n  />\n  <ng-content select=\"[label-toggle]\"></ng-content>\n</div>\n", styles: ["@import\"https://cdn-doku.oss-ap-southeast-5.aliyuncs.com/doku-ui-framework/css-doku@1.0.4/css/main.css\";@import\"https://cdn-doku.oss-ap-southeast-5.aliyuncs.com/doku-ui-framework/css-jokul/1.0.0/main.css\";\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { onClicked: [{
                type: Output
            }], id: [{
                type: Input
            }], checked: [{
                type: Input
            }], disabled: [{
                type: Input
            }] } });

class DragAndDropDirective {
    constructor() {
        this.fileDropped = new EventEmitter();
        this.background = '#FAFAFA';
    }
    // Dragover Event
    dragOver(event) {
        event.preventDefault();
        event.stopPropagation();
        this.background = '#d9d9d9';
    }
    // Dragleave Event
    dragLeave(event) {
        event.preventDefault();
        event.stopPropagation();
        this.background = '#FAFAFA';
    }
    // Drop Event
    drop(event) {
        event.preventDefault();
        event.stopPropagation();
        this.background = '#FAFAFA';
        const files = event.dataTransfer.files;
        if (files.length > 0) {
            this.fileDropped.emit(files);
        }
    }
}
DragAndDropDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DragAndDropDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
DragAndDropDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.12", type: DragAndDropDirective, selector: "[appDragDropFileUpload]", outputs: { fileDropped: "fileDropped" }, host: { listeners: { "dragover": "dragOver($event)", "dragleave": "dragLeave($event)", "drop": "drop($event)" }, properties: { "style.background-color": "this.background" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DragAndDropDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[appDragDropFileUpload]',
                }]
        }], propDecorators: { fileDropped: [{
                type: Output
            }], background: [{
                type: HostBinding,
                args: ['style.background-color']
            }], dragOver: [{
                type: HostListener,
                args: ['dragover', ['$event']]
            }], dragLeave: [{
                type: HostListener,
                args: ['dragleave', ['$event']]
            }], drop: [{
                type: HostListener,
                args: ['drop', ['$event']]
            }] } });

let componentId = 1;
class DokuUploadFileComponent {
    constructor() {
        this.size1MB = 1048576; // 1048576 bytes = 1MB
        this.id = `upload-file-${componentId++}`;
        this.title = 'Upload';
        this.subtitle = null;
        /**
         * Sets a comma-separated list of content types.
         * It's the same attribute as in HTML input tag.
         *
         * See content/mime types reference
         * @link
         * https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types/Common_types
         */
        this.accept = '*';
        /**
         * The value is in MB.
         * Default max file size is 5MB.
         */
        this.maxSize = 5;
        /**
         * Whether the field is invalid or not.
         * The field background will gonna be red if invalid.
         */
        this.invalid = false;
        this.onUpload = false;
        /**
         * Whether the file is remove-able.
         * Default to `true`.
         */
        this.removeAble = true;
        /**
         * Whether the file upload input is disabled.
         * Default to `false`.
         */
        this.disabled = false;
        /**
          * preview image will show or not.
          * Default to `true`.
          */
        this.showImage = true;
        /**
        * title will be dynamic if true.
        * Default to `true`.
        */
        this.dynamicTitle = true;
        this.canDownloadFile = false;
        this.fileChange = new EventEmitter();
        this.fileViewer = new EventEmitter();
        this.fileRemove = new EventEmitter();
        this.fileError = new EventEmitter();
        this.lang = "ID";
        this.loading = false;
        this.imagePreviewSrc = null;
        this.file = null;
        window.onResize = this.onResize.bind(this);
        var langCode = localStorage.getItem('selected-language');
        this.lang = langCode ? langCode : 'ID';
    }
    ngOnChanges(changes) {
        this.loading = true;
        if (changes['initialFile']) {
            this.showFilePreview(this.initialFile);
        }
    }
    get isFileExist() {
        return !!this.file || !!this.initialFile;
    }
    get isImage() {
        if (!this.isFileExist)
            return false;
        if (this.showImage) {
            return this.checkFileIsImage(this.file || this.initialFile);
        }
        else {
            return this.showImage;
        }
    }
    ngAfterViewInit() {
        this.onResize();
    }
    onResize() {
        var _a;
        var innerWidth = (_a = document.getElementById("upload-box-file")) === null || _a === void 0 ? void 0 : _a.clientWidth;
        if (innerWidth) {
            var newWidth = `${innerWidth * 0.7}px`;
            let elem = document.getElementById('title');
            elem === null || elem === void 0 ? void 0 : elem.setAttribute("style", `width:${newWidth};
      white-space: nowrap;
      overflow: hidden;
      text-overflow: ellipsis;
      text-align:left`);
        }
    }
    onPreviewImage(element) {
        if (this.disabled)
            return;
        if (this.canDownloadFile) {
            this.fileViewer.emit(this.initialFile);
        }
        else {
            element.click();
        }
    }
    onFileChange(event) {
        var _a;
        if (this.disabled)
            return;
        this.loading = true;
        const target = event.target;
        const file = (_a = target.files) === null || _a === void 0 ? void 0 : _a[0];
        this.handleFileChange(file);
        target.value = '';
    }
    onFileDropped(fileList) {
        if (this.disabled)
            return;
        const file = fileList.item(0);
        this.handleFileChange(file);
    }
    onFileRemove(event) {
        if (this.disabled)
            return;
        event.stopPropagation();
        this.nameFile = "";
        this.file = null;
        this.initialFile = undefined;
        this.imagePreviewSrc = null;
        this.fileRemove.emit();
    }
    handleFileChange(file) {
        if (!file) {
            return this.fileError.emit('empty');
        }
        if (!this.validateFileType(file)) {
            return this.fileError.emit('fileType');
        }
        if (!this.validateFileSizeLimit(file.size)) {
            return this.fileError.emit('fileSize');
        }
        this.file = file;
        this.showFilePreview(file);
        this.fileChange.emit(file);
    }
    showFilePreview(file) {
        this.loading = false;
        if (!file)
            return;
        if (file.name) {
            this.nameFile = file.name;
        }
        else {
            this.nameFile = file.substring(file.lastIndexOf('/') + 1);
        }
        if (this.checkFileIsImage(file)) {
            return this.showImagePreview(file);
        }
    }
    showImagePreview(file) {
        if (file instanceof File) {
            const reader = new FileReader();
            reader.readAsDataURL(file);
            reader.onload = () => {
                this.imagePreviewSrc = reader.result;
            };
            return;
        }
        if (typeof file === 'string') {
            this.imagePreviewSrc = file;
            return;
        }
    }
    checkFileIsImage(file) {
        if (file instanceof File) {
            return file.type.startsWith('image/');
        }
        if (typeof file === 'string') {
            const imageUrlRegex = new RegExp(/^https?:\/\/.*\.(jpg|jpeg|png|webp|avif|gif|svg)(\?)?/);
            return imageUrlRegex.test(file);
        }
        return false;
    }
    validateFileSizeLimit(size) {
        const maxSize = this.maxSize * this.size1MB;
        return size <= maxSize;
    }
    validateFileType(file) {
        let accept = this.accept;
        // Normalize "accept" if it is string array.
        if (/\[.*\]/.test(accept)) {
            accept = JSON.parse(accept);
        }
        // Normalize "accept" if it is array.
        if (Array.isArray(this.accept)) {
            accept = this.accept.join();
        }
        const accepts = accept.split(',').map(item => item.trim());
        const validationMap = accepts.map(item => {
            // Check file extension
            if (item.startsWith('.')) {
                return file.name.endsWith(item);
            }
            // Check file type starting words before "/""
            // Example:
            // - image/*
            // - video/*
            if (/\*/.test(item)) {
                const normalizedItem = item.replace('*', '');
                return file.type.startsWith(normalizedItem);
            }
            // Otherwise, will check actual type.
            return file.type === item;
        });
        // It's valid if file type meet one of the accepted types.
        return validationMap.some(val => val);
    }
}
DokuUploadFileComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuUploadFileComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DokuUploadFileComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.12", type: DokuUploadFileComponent, selector: "doku-upload-file", inputs: { id: "id", title: "title", subtitle: "subtitle", accept: "accept", maxSize: "maxSize", initialFile: "initialFile", invalid: "invalid", onUpload: "onUpload", removeAble: "removeAble", disabled: "disabled", showImage: "showImage", dynamicTitle: "dynamicTitle", canDownloadFile: "canDownloadFile" }, outputs: { fileChange: "fileChange", fileViewer: "fileViewer", fileRemove: "fileRemove", fileError: "fileError" }, host: { listeners: { "window:resize": "onResize($event)" } }, usesOnChanges: true, ngImport: i0, template: "<div\n  class=\"card upload-box\"\n  [class.filled]=\"isFileExist && !canDownloadFile\"\n  [class.invalid]=\"invalid\"\n  [class.disabled]=\"disabled\"\n  (click)=\"onPreviewImage(inputFile)\"\n  appDragDropFileUpload\n  (fileDropped)=\"onFileDropped($event)\"\n>\n  <input\n    #inputFile\n    type=\"file\"\n    style=\"display: none;\"\n    [accept]=\"accept\"\n    (change)=\"onFileChange($event)\"\n    [id]=\"id\"\n  />\n\n  <div class=\"card-body text-center\" id=\"upload-box-file\">\n    <div class=\"file-viewer\">\n      <div *ngIf=\"!isFileExist\" class=\"choose-file\"><i class=\"fas fa-plus\" style=\"color: white;\"></i></div>\n      <ng-container *ngIf=\"isFileExist\">\n        <img *ngIf=\"isImage\" [src]=\"imagePreviewSrc\" alt=\"Image preview\" class=\"show-image\">\n        <span *ngIf=\"!isImage\" class=\"choose-file\"><i class=\"far fa-file\"></i></span>\n      </ng-container>\n    </div>\n\n    <div class=\"info\">\n      <ng-container>\n        <div class=\"title\" id=\"title\" *ngIf=\"!nameFile || !dynamicTitle\">{{title}}</div>\n        <div class=\"title\" id=\"title\" *ngIf=\"nameFile && dynamicTitle\">{{nameFile}}</div>\n        <p>\n          <ng-container *ngIf=\"subtitle  && !canDownloadFile && !isFileExist && !onUpload\">{{subtitle}}</ng-container>\n          <ng-container *ngIf=\"nameFile  && !canDownloadFile && isFileExist && !onUpload && lang === 'EN'\">Tap here to change the file</ng-container>\n          <ng-container *ngIf=\"nameFile && !canDownloadFile && isFileExist && !onUpload && lang === 'ID'\">Tap here to change the file</ng-container>\n          <ng-container *ngIf=\"isFileExist && canDownloadFile\">Click here to download the file</ng-container>\n        </p>\n        <ng-content select=\"[status]\"></ng-content>\n      </ng-container>\n    </div>\n\n    <div *ngIf=\"removeAble && isFileExist && !disabled\" class=\"remove-file\">\n      <div *ngIf=\"!loading && !canDownloadFile\" class=\"icon-wrapper ml-3\" (click)=\"onFileRemove($event)\">\n        <i class=\"fas fa-times\"></i>\n      </div>\n      <div  *ngIf=\"loading\" class=\"icon-wrapper ml-3\">\n        <div class=\"spinner-border spinner-border-sm text-danger\" role=\"status\">\n            <span class=\"visually-hidden\">Loading...</span>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n", styles: [".upload-box{background:transparent;border-radius:8px;height:70px;border:1px dashed #ccc;overflow:hidden}.choose-file{background:#ABB4C0;border-radius:4px;width:100%;height:100%;padding-top:8px;text-align:center}.show-file{background:#ABB4C0;border-radius:4px;width:36px;display:inherit;height:36px;padding-top:8px;margin-right:12px}.card.upload-box.invalid{background:#FFEFEE!important;border:1px dashed #BB1F17!important}.card.upload-box.disabled{background:#E5E8EC!important}.upload-box:hover{cursor:pointer;background-color:#00000003!important}.upload-box.filled{background-color:#cceceb!important;border-color:#00a19b}.upload-box.normal{border-color:#818995}.upload-box .card-body{padding:16px!important;display:flex;align-items:center}.upload-box .image-wrapper{border-radius:4px;background-color:#eaecf0;width:36px;height:36px;display:flex;align-items:center;justify-content:center;margin-right:14px}.upload-box .image-wrapper .show-image{width:100%;height:100%;object-fit:cover}.upload-box .info{display:flex;flex-direction:column;align-items:flex-start}.upload-box .info .title{font-weight:700;color:#333}.upload-box .info p{color:#4d4d4d;margin-bottom:0;font-size:12px}.card-body.text-center.disabled{background:#e5e8ec!important;cursor:no-drop}.upload-box-document{width:96px;height:115px;background:#d9d9d9;border-radius:8px;border:0}.upload-box-document .card-body{color:#f2f2f2;display:flex;align-items:center;justify-content:center;font-size:18px;font-weight:700}img.show-image{width:100%;height:100%;object-fit:cover}.file-viewer{width:36px;height:36px;display:flex;align-items:center;justify-content:center;margin-right:12px;border-radius:4px;overflow:hidden}\n"], dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: DragAndDropDirective, selector: "[appDragDropFileUpload]", outputs: ["fileDropped"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuUploadFileComponent, decorators: [{
            type: Component,
            args: [{ selector: 'doku-upload-file', template: "<div\n  class=\"card upload-box\"\n  [class.filled]=\"isFileExist && !canDownloadFile\"\n  [class.invalid]=\"invalid\"\n  [class.disabled]=\"disabled\"\n  (click)=\"onPreviewImage(inputFile)\"\n  appDragDropFileUpload\n  (fileDropped)=\"onFileDropped($event)\"\n>\n  <input\n    #inputFile\n    type=\"file\"\n    style=\"display: none;\"\n    [accept]=\"accept\"\n    (change)=\"onFileChange($event)\"\n    [id]=\"id\"\n  />\n\n  <div class=\"card-body text-center\" id=\"upload-box-file\">\n    <div class=\"file-viewer\">\n      <div *ngIf=\"!isFileExist\" class=\"choose-file\"><i class=\"fas fa-plus\" style=\"color: white;\"></i></div>\n      <ng-container *ngIf=\"isFileExist\">\n        <img *ngIf=\"isImage\" [src]=\"imagePreviewSrc\" alt=\"Image preview\" class=\"show-image\">\n        <span *ngIf=\"!isImage\" class=\"choose-file\"><i class=\"far fa-file\"></i></span>\n      </ng-container>\n    </div>\n\n    <div class=\"info\">\n      <ng-container>\n        <div class=\"title\" id=\"title\" *ngIf=\"!nameFile || !dynamicTitle\">{{title}}</div>\n        <div class=\"title\" id=\"title\" *ngIf=\"nameFile && dynamicTitle\">{{nameFile}}</div>\n        <p>\n          <ng-container *ngIf=\"subtitle  && !canDownloadFile && !isFileExist && !onUpload\">{{subtitle}}</ng-container>\n          <ng-container *ngIf=\"nameFile  && !canDownloadFile && isFileExist && !onUpload && lang === 'EN'\">Tap here to change the file</ng-container>\n          <ng-container *ngIf=\"nameFile && !canDownloadFile && isFileExist && !onUpload && lang === 'ID'\">Tap here to change the file</ng-container>\n          <ng-container *ngIf=\"isFileExist && canDownloadFile\">Click here to download the file</ng-container>\n        </p>\n        <ng-content select=\"[status]\"></ng-content>\n      </ng-container>\n    </div>\n\n    <div *ngIf=\"removeAble && isFileExist && !disabled\" class=\"remove-file\">\n      <div *ngIf=\"!loading && !canDownloadFile\" class=\"icon-wrapper ml-3\" (click)=\"onFileRemove($event)\">\n        <i class=\"fas fa-times\"></i>\n      </div>\n      <div  *ngIf=\"loading\" class=\"icon-wrapper ml-3\">\n        <div class=\"spinner-border spinner-border-sm text-danger\" role=\"status\">\n            <span class=\"visually-hidden\">Loading...</span>\n        </div>\n      </div>\n    </div>\n  </div>\n</div>\n", styles: [".upload-box{background:transparent;border-radius:8px;height:70px;border:1px dashed #ccc;overflow:hidden}.choose-file{background:#ABB4C0;border-radius:4px;width:100%;height:100%;padding-top:8px;text-align:center}.show-file{background:#ABB4C0;border-radius:4px;width:36px;display:inherit;height:36px;padding-top:8px;margin-right:12px}.card.upload-box.invalid{background:#FFEFEE!important;border:1px dashed #BB1F17!important}.card.upload-box.disabled{background:#E5E8EC!important}.upload-box:hover{cursor:pointer;background-color:#00000003!important}.upload-box.filled{background-color:#cceceb!important;border-color:#00a19b}.upload-box.normal{border-color:#818995}.upload-box .card-body{padding:16px!important;display:flex;align-items:center}.upload-box .image-wrapper{border-radius:4px;background-color:#eaecf0;width:36px;height:36px;display:flex;align-items:center;justify-content:center;margin-right:14px}.upload-box .image-wrapper .show-image{width:100%;height:100%;object-fit:cover}.upload-box .info{display:flex;flex-direction:column;align-items:flex-start}.upload-box .info .title{font-weight:700;color:#333}.upload-box .info p{color:#4d4d4d;margin-bottom:0;font-size:12px}.card-body.text-center.disabled{background:#e5e8ec!important;cursor:no-drop}.upload-box-document{width:96px;height:115px;background:#d9d9d9;border-radius:8px;border:0}.upload-box-document .card-body{color:#f2f2f2;display:flex;align-items:center;justify-content:center;font-size:18px;font-weight:700}img.show-image{width:100%;height:100%;object-fit:cover}.file-viewer{width:36px;height:36px;display:flex;align-items:center;justify-content:center;margin-right:12px;border-radius:4px;overflow:hidden}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { id: [{
                type: Input
            }], title: [{
                type: Input
            }], subtitle: [{
                type: Input
            }], accept: [{
                type: Input
            }], maxSize: [{
                type: Input
            }], initialFile: [{
                type: Input
            }], invalid: [{
                type: Input
            }], onUpload: [{
                type: Input
            }], removeAble: [{
                type: Input
            }], disabled: [{
                type: Input
            }], showImage: [{
                type: Input
            }], dynamicTitle: [{
                type: Input
            }], canDownloadFile: [{
                type: Input
            }], fileChange: [{
                type: Output
            }], fileViewer: [{
                type: Output
            }], fileRemove: [{
                type: Output
            }], fileError: [{
                type: Output
            }], onResize: [{
                type: HostListener,
                args: ['window:resize', ['$event']]
            }] } });

class DokuSessionService {
    constructor() { }
    /**
     * Store anything to local storage.
     * @param {string} key
     * @param val
     */
    setLocalItem(key, val) {
        localStorage.setItem(key, JSON.stringify(val));
    }
    /**
     * Retrieve anything from local storage.
     * @param {string} key
     * @returns {any}
     */
    getLocalItem(key) {
        return localStorage.getItem(key);
    }
    /**
     * get current user session
     */
    getToken() {
        return this.getLocalItem('token');
    }
    /**
     * check whether user is login or not
     */
    isLoggedIn() {
        const isHasToken = this.getToken();
        const isHasUser = this.getLocalItem('user');
        if (isHasToken && isHasUser) {
            return isHasToken;
        }
        else {
            var token = 'authnologin';
            return token;
        }
    }
    /**
     * clear current session
     */
    destroySession() {
        localStorage.clear();
    }
}
DokuSessionService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuSessionService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
DokuSessionService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuSessionService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuSessionService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

class DokuApiService {
    constructor(router, http, dokuSession) {
        this.router = router;
        this.http = http;
        this.dokuSession = dokuSession;
    }
    get(path, parameters, headersOptions) {
        return this.requestGet(path, parameters, headersOptions);
    }
    post(path, parameters, body, headersOptions) {
        this.setBodyJSON(body);
        return this.requestPost(path, parameters, headersOptions);
    }
    upload(path, parameters, body, headersOptions) {
        this.setBodyJSON(body);
        return this.requestUpload(path, parameters, headersOptions);
    }
    uploadFile(path, formData, headersOptions) {
        return this.http.post(path, formData, {
            headers: headersOptions ? headersOptions : this.getUploadHeaders(),
            observe: 'response',
        });
    }
    put(path, parameters, body, headersOptions) {
        this.setBodyJSON(body);
        return this.requestPut(path, parameters, headersOptions);
    }
    delete(path, parameters, body, headersOptions) {
        this.setBodyJSON(body);
        return this.requestDelete(path, parameters, headersOptions);
    }
    requestGet(path, parameters, headersOptions) {
        const headersDefault = this.getHeaders();
        const headers = headersOptions ? headersOptions : headersDefault;
        const params = this.params(parameters);
        return this.http.get(path, { headers, params, observe: 'response' }).pipe(map((response) => this.responseProcessor(response)), catchError((error) => {
            return throwError(() => error);
        }));
    }
    requestPost(path, parameters, headersOptions) {
        const params = this.params(parameters);
        const headersDefault = this.getHeaders();
        const headers = headersOptions ? headersOptions : headersDefault;
        return this.http
            .post(path, this.getBodyJSON(), { headers, params, observe: 'response' })
            .pipe(map((response) => this.responseProcessor(response)), catchError((error) => {
            return throwError(() => error);
        }));
    }
    requestPut(path, parameters, headersOptions) {
        const params = this.params(parameters);
        const headersDefault = this.getHeaders();
        const headers = headersOptions ? headersOptions : headersDefault;
        return this.http
            .put(path, this.getBodyJSON(), { headers, params, observe: 'response' })
            .pipe(map((response) => this.responseProcessor(response)), catchError((error) => {
            return throwError(() => error);
        }));
    }
    requestDelete(path, parameters, headersOptions) {
        const params = this.params(parameters);
        const headersDefault = this.getHeaders();
        const headers = headersOptions ? headersOptions : headersDefault;
        return this.http
            .delete(path, { headers, params, observe: 'response' })
            .pipe(map((response) => this.responseProcessor(response)), catchError((error) => {
            return throwError(() => error);
        }));
    }
    requestUpload(path, parameters, headersOptions) {
        const params = this.params(parameters);
        const headersDefault = this.getUploadHeaders();
        const headers = headersOptions ? headersOptions : headersDefault;
        return this.http
            .post(path, this.getBodyJSON(), { headers, params, observe: 'response' })
            .pipe(map((response) => this.responseProcessor(response)), catchError((error) => {
            return throwError(() => error);
        }));
    }
    responseProcessor(response) {
        if (response.headers.get('refreshed-token') &&
            response.headers.get('refreshed-token')) {
            this.dokuSession.setLocalItem('token', response.headers.get('refreshed-token'));
        }
        if (response.status == 200) {
            var res = response.body;
            return res;
        }
    }
    setContentPathURL(contentPathURL) {
        this.contentPathURL = contentPathURL;
        return this;
    }
    getContentPathURL() {
        return this.contentPathURL;
    }
    setPathParameters(pathParameters) {
        this.pathParameters = pathParameters;
        return this;
    }
    getpathParameters() {
        return this.pathParameters;
    }
    setBodyJSON(body) {
        this.bodyJSON = JSON.stringify(body);
        return this;
    }
    getBodyJSON() {
        return this.bodyJSON;
    }
    getHeaders() {
        const headers = new HttpHeaders({
            'Content-Type': 'application/json; charset=utf-8',
            Authorization: `bearer ${this.dokuSession.isLoggedIn()}`,
        });
        return headers;
    }
    getUploadHeaders() {
        const headers = new HttpHeaders({
            'Content-Type': 'multipart/form-data; charset=utf-8',
            Authorization: `bearer ${this.dokuSession.isLoggedIn()}}`,
            'Access-Control-Allow-Origin': '*',
        });
        return headers;
    }
    params(parameters) {
        return new HttpParams({ fromObject: parameters });
    }
    getFullRequestURL() {
        let fullRequestURL = this.getContentPathURL();
        if (this.pathParameters) {
            this.pathParameters.forEach((value, key) => {
                fullRequestURL = fullRequestURL === null || fullRequestURL === void 0 ? void 0 : fullRequestURL.replace(key, value);
            });
        }
        if ((fullRequestURL === null || fullRequestURL === void 0 ? void 0 : fullRequestURL.indexOf('sort=')) === -1) {
            if (fullRequestURL.indexOf('?') === -1) {
                fullRequestURL = fullRequestURL;
            }
            else {
                fullRequestURL = fullRequestURL;
            }
        }
        return fullRequestURL;
    }
}
DokuApiService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuApiService, deps: [{ token: i1$2.Router }, { token: i2$1.HttpClient }, { token: DokuSessionService }], target: i0.ɵɵFactoryTarget.Injectable });
DokuApiService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuApiService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuApiService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return [{ type: i1$2.Router }, { type: i2$1.HttpClient }, { type: DokuSessionService }]; } });

class DokuUiModule {
}
DokuUiModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuUiModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
DokuUiModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.12", ngImport: i0, type: DokuUiModule, declarations: [DokuPaginationComponent,
        DokuSortableHeaderColumnDirective,
        DokuSortableHeaderRowDirective,
        DokuSpinnerComponent,
        DokuToastComponent,
        DokuUploadFileComponent,
        DragAndDropDirective,
        DokuBottomSheetComponent,
        DokuToggleComponent,
        DokuConfirmationModalComponent], imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule,
        NgbModule,
        HttpClientModule], exports: [DokuPaginationComponent,
        DokuSortableHeaderColumnDirective,
        DokuSortableHeaderRowDirective,
        DokuSpinnerComponent,
        DokuToastComponent,
        DokuUploadFileComponent,
        DragAndDropDirective,
        DokuBottomSheetComponent,
        DokuToggleComponent] });
DokuUiModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuUiModule, providers: [DokuApiService, DokuSessionService], imports: [CommonModule,
        FormsModule,
        ReactiveFormsModule,
        NgbModule,
        HttpClientModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.12", ngImport: i0, type: DokuUiModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        DokuPaginationComponent,
                        DokuSortableHeaderColumnDirective,
                        DokuSortableHeaderRowDirective,
                        DokuSpinnerComponent,
                        DokuToastComponent,
                        DokuUploadFileComponent,
                        DragAndDropDirective,
                        DokuBottomSheetComponent,
                        DokuToggleComponent,
                        DokuConfirmationModalComponent,
                    ],
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        NgbModule,
                        HttpClientModule,
                    ],
                    exports: [
                        DokuPaginationComponent,
                        DokuSortableHeaderColumnDirective,
                        DokuSortableHeaderRowDirective,
                        DokuSpinnerComponent,
                        DokuToastComponent,
                        DokuUploadFileComponent,
                        DragAndDropDirective,
                        DokuBottomSheetComponent,
                        DokuToggleComponent,
                    ],
                    providers: [DokuApiService, DokuSessionService],
                }]
        }] });

/*
 * Public API Surface of doku-ui
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DokuApiService, DokuBottomSheetComponent, DokuBottomSheetConfig, DokuConfirmationModalComponent, DokuLoaderService, DokuPaginationComponent, DokuSessionService, DokuSortableHeaderColumnDirective, DokuSortableHeaderRowDirective, DokuSpinnerComponent, DokuToastComponent, DokuToggleComponent, DokuUiModule, DokuUploadFileComponent, DragAndDropDirective, ToastService };
//# sourceMappingURL=doku-ui.mjs.map
